local FRACUNIT = FRACUNIT
local TICRATE = TICRATE

local function K_MomentumAngleEx(mo, threshold)
	if (FixedHypot(mo.momx, mo.momy) > threshold) then
		return R_PointToAngle2(0, 0, mo.momx, mo.momy)
	else
		return mo.angle
	end
end

local function K_MomentumAngle(mo)
	return K_MomentumAngleEx(mo, 6*mo.scale)
end

local function IsPlayerHurt(p)
	if p.kartstuff[k_spinouttimer]
	or p.kartstuff[k_squishedtimer]
	or p.playerstate == PST_DEAD
	or p.playerstate == PST_RESPAWN
	or p.kartstuff[k_respawn]
		return true
	end
	return false
end

local function RR_MoveInit(p)
	p.RRoldDriftCharge = 0
	p.RRoldDriftBoost = 0
	p.RRoldBounce = 0
	p.RRoldButtons = 0
end
addHook("PlayerSpawn", RR_MoveInit)

local function RR_Movement(p)
	local onground = P_IsObjectOnGround(p.mo)

	if p.RRoldDriftBoost ~= nil then
		if ((p.RRoldDriftCharge > p.kartstuff[k_driftcharge])
		or (not (p.cmd.buttons & BT_DRIFT) and (not P_IsObjectOnGround(p.mo)) and (p.RRoldDriftCharge == p.kartstuff[k_driftcharge])))
		and not IsPlayerHurt(p) then
			local pushdir = K_MomentumAngle(p.mo)
			local oldDriftBooster = p.kartstuff[k_driftboost]
		
			local target = K_GetKartDriftSparkValue(p) -- Taken from source.
			local LDC = p.RRoldDriftCharge
			
			if p.RRoldBounce then
				return
			elseif p.speed <= 10*FRACUNIT then
				return
			elseif IsPlayerHurt(p) then
				return
			elseif LDC < target then
				return
			elseif p.RRoldButtons and (p.cmd.buttons & BT_DRIFT)
				return
			else
				if LDC >= target*4 then -- Rainbow and red MT values taken from source.
					p.kartstuff[k_driftboost] = max($, 125)
				elseif LDC >= target*3 then -- Yep, we're doing this lmao
					p.kartstuff[k_driftboost] = max($, 85)
				elseif LDC >= target*2 then
					p.kartstuff[k_driftboost] = max($, 50)
				elseif LDC >= target then
					p.kartstuff[k_driftboost] = max($, 20)
				end
			end
	
			-- A small piece of the larger puzzle that is this potential project
			if (p.kartstuff[k_driftboost] > oldDriftBooster)
				p.kartstuff[k_driftboost] = (58 - (p.kartweight + p.kartspeed)) * p.kartstuff[k_driftboost] / 40
			end
		end
	end
	--print("Drift Charge Check 2: "..p.kartstuff[k_driftcharge])
end
addHook("ThinkFrame", function()
	if leveltime == 0 then return end
	
	for p in players.iterate
		if not (p.mo and p.mo.valid) then continue end
		if p.spectator then continue end
		
		RR_Movement(p)
		
		p.RRoldDriftBoost = p.kartstuff[k_driftboost]
		p.RRoldDriftCharge = p.kartstuff[k_driftcharge]
		p.RRoldButtons = p.cmd.buttons & BT_DRIFT
		p.RRoldBounce = p.mo.eflags & MFE_JUSTBOUNCEDWALL
	end
end)

addHook("MobjThinker", function(mo)
	if not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid and mo.target.player) then return end
	
	local p = mo.target.player
	p.RRTierThree = $ or 0
	
	if p.RRGrowtics then
		p.RRGrowtics = $-1
	end

	if p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p)*3
	and p.kartstuff[k_driftcharge] < K_GetKartDriftSparkValue(p)*4 then
		if not p.RRTierThree then
			S_StartSoundAtVolume(p.mo, sfx_s3ka2, 192)
			p.RRGrowtics = 8
		end

		if p.kartstuff[k_driftcharge] <= (K_GetKartDriftSparkValue(p)*3)+(24*3) then
			mo.color = SKINCOLOR_BLUE
		else
			mo.color = SKINCOLOR_SAPPHIRE
		end
		
		local extraScale = 0
		
		if p.RRGrowtics then
			local pulse = CV_FindVar("driftsparkpulse").value or 7*FRACUNIT/5
			extraScale = FixedDiv(p.RRGrowtics*FRACUNIT, 8*FRACUNIT)
			
			mo.scale = FixedMul(mo.target.scale, FRACUNIT + FixedMul(extraScale, pulse))
		else
			mo.scale = mo.target.scale
		end
	elseif p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p)
	and p.kartstuff[k_driftcharge] < K_GetKartDriftSparkValue(p)*2
		mo.color = SKINCOLOR_YELLOW
	end
	
	p.RRTierThree = (p.kartstuff[k_driftcharge] >= K_GetKartDriftSparkValue(p)*3)
end, MT_DRIFTSPARK)